/*
 * This file is part of vospace-file-catalog
 * Copyright (C) 2021 Istituto Nazionale di Astrofisica
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

-- View that maps node_id to vos_path (path in VOSpace)

CREATE VIEW node_vos_path AS
WITH RECURSIVE r_vos_path AS (
    SELECT node_id, path, name AS vos_path
    FROM node
    WHERE name = ''
  UNION ALL
    SELECT n.node_id, n.path, p.vos_path || '/' || name
    FROM node n
    JOIN r_vos_path p ON p.path = n.parent_path
)
SELECT node_id, (CASE WHEN path = '' THEN '/' ELSE vos_path END) AS vos_path FROM r_vos_path;